## prometheus-exporter-exporter 0.4.0

=== Makefile ===
GITHUB_ORG  = QubitProducts
GITHUB_REPO = exporter_exporter
VERSION      = 0.4.0

DOCKER_REGISTRY     = qubitproducts
DOCKER_NAME         = exporter_exporter
DOCKER_IMAGE        = $(DOCKER_REGISTRY)/$(DOCKER_NAME):$(VERSION)
DOCKER_IMAGE_LATEST = $(DOCKER_REGISTRY)/$(DOCKER_NAME):latest

SHELL        := /usr/bin/env bash
GO           := go
FIRST_GOPATH := $(firstword $(subst :, ,$(GOPATH)))
FILES         = $(shell find . -name '*.go' | grep -v vendor)
PREFIX       ?= $(shell pwd)
BIN_DIR      ?= $(shell pwd)

PACKAGE_TARGET     = deb
PACKAGE_NAME       = expexp
PACKAGE_VERSION    = $(VERSION)
PACKAGE_REVISION   = 3
PACKAGE_ARCH       = amd64
PACKAGE_MAINTAINER = tristan@qubit.com
PACKAGE_FILE       = $(PACKAGE_NAME)_$(PACKAGE_VERSION)-$(PACKAGE_REVISION)_$(PACKAGE_ARCH).$(PACKAGE_TARGET)
BINNAME            = exporter_exporter

PWD := $(shell pwd)

all: package
clean:
	rm -f $(PACKAGE_FILE)
	rm -rf dist
	rm -rf build

.PHONY: test
test:
	echo ">> running short tests"
	$(GO) test -short $(pkgs)

.PHONY: test-static
test-static:
	echo ">> running static tests"
	$(GO) vet $(pkgs)
	[[ "$(shell gofmt -l $(files))" == "" ]] || (echo "gofmt check failed"; exit 1)

.PHONY: format
format:
	echo ">> formatting code"
	$(GO) fmt $(pkgs)

.PHONY: vet
vet:
	echo ">> vetting code"
	$(GO) vet $(pkgs)

.PHONY: prepare-package clean-package package
prepare-package: clean-package build/$(BINNAME)-$(VERSION).linux-amd64/$(BINNAME)
	mkdir -p dist/usr/local/bin
	mkdir -p dist/etc/init
	mkdir -p dist/etc/default
	mkdir -p dist/etc/exporter_exporter.d/
	install -m755 build/$(BINNAME)-$(VERSION).linux-amd64/$(BINNAME) dist/usr/local/bin/$(BINNAME)
	install -m644 $(BINNAME).conf dist/etc/init/$(BINNAME).conf
	install -m644 $(BINNAME).defaults dist/etc/default/$(BINNAME)
	install -m644 expexp.yaml dist/etc/exporter_exporter.yaml
	touch dist/etc/exporter_exporter.d/.dir

clean-package:
	rm -rf dist

.PHONY: AUTHORS
AUTHORS:
	# There's only so much credit I need.
	git log --format='%aN <%aE>' | grep -v Tristan\ Colgate\  | sort -u > AUTHORS

$(PACKAGE_FILE): prepare-package
	cd dist && \
	  fpm \
	  -t $(PACKAGE_TARGET) \
	  -m $(PACKAGE_MAINTAINER) \
	  -n $(PACKAGE_NAME) \
	  -a $(PACKAGE_ARCH) \
	  -v $(PACKAGE_VERSION) \
	  --iteration $(PACKAGE_REVISION) \
	  --config-files /etc/$(BINNAME).yaml \
	  --config-files /etc/init/$(BINNAME).conf \
	  --config-files /etc/default/$(BINNAME) \
	  -s dir \
	  -p ../$(PACKAGE_FILE) \
	  .

.PHONY: build-docker release-docker
build-docker: 
	docker build -t $(DOCKER_IMAGE) .

release-docker: build-docker
	docker push $(DOCKER_IMAGE)
	docker tag $(DOCKER_IMAGE) $(DOCKER_IMAGE_LATEST)
	docker push $(DOCKER_IMAGE_LATEST)

LDFLAGS = -X main.Version=$(VERSION) \
					-X main.Branch=$(BRANCH) \
					-X main.Revision=$(REVISION) \
					-X main.BuildUser=$(BUILDUSER) \
					-X main.BuildDate=$(BUILDDATE)

build/$(BINNAME)-$(VERSION).windows-amd64/$(BINNAME).exe: $(SRCS)
	GOOS=$* GOARCH=amd64 $(GO) build \
	 -ldflags "$(LDFLAGS)" \
	 -o $@ \
	 .
build/$(BINNAME)-$(VERSION).windows-amd64.zip: build/expoter_exporter-$(VERSION).windows-amd64/$(BINNAME).exe
	zip $@ $<

build/$(BINNAME)-$(VERSION).%-amd64/$(BINNAME): $(SRCS)
	GOOS=$* GOARCH=amd64 $(GO) build \
	 -ldflags  "$(LDFLAGS)" \
	 -o $@ \
	 .

build/$(BINNAME)-$(VERSION).%-amd64.tar.gz: build/$(BINNAME)-$(VERSION).%-amd64/$(BINNAME)
	cd build && \
		tar cfzv $(BINNAME)-$(VERSION).$*-amd64.tar.gz $(BINNAME)-$(VERSION).$*-amd64


package: $(PACKAGE_FILE)

package-release: $(PACKAGE_FILE)
	go run github.com/aktau/github-release upload \
	  -u $(GITHUB_ORG) \
	 	-r $(GITHUB_REPO) \
	 	--tag v$(VERSION) \
		--name $(PACKAGE_FILE) \
		--file $(PACKAGE_FILE)

release-windows: build/exporter_exporter-$(VERSION).windows-amd64.zip
	go run github.com/aktau/github-release upload \
		-u $(GITHUB_ORG) \
		-r $(GITHUB_REPO) \
		--tag v$(VERSION) \
		--name exporter_exporter-$(VERSION).windows-amd64.zip \
		-f ./build/exporter_exporter-$(VERSION).windows-amd64.zip

release-%: build/exporter_exporter-$(VERSION).%-amd64.tar.gz
	go run github.com/aktau/github-release upload \
		-u $(GITHUB_ORG) \
		-r $(GITHUB_REPO) \
		--tag v$(VERSION) \
		--name exporter_exporter-$(VERSION).$*-amd64.tar.gz \
		-f ./build/exporter_exporter-$(VERSION).$*-amd64.tar.gz

release: 
	git tag v$(VERSION)
	git push origin v$(VERSION)
	go run github.com/aktau/github-release release \
		-u $(GITHUB_ORG) \
		-r $(GITHUB_REPO) \
		--tag v$(VERSION) \
		--name v$(VERSION)
	make release-darwin release-linux release-windows package-release

=== debian/changelog ===
prometheus-exporter-exporter (0.4.0-1ubuntu0.24.04.3) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Thu, 26 Jun 2025 11:07:35 +1000

prometheus-exporter-exporter (0.4.0-1ubuntu0.24.04.2) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Thu, 07 Nov 2024 13:56:43 +1000

prometheus-exporter-exporter (0.4.0-1ubuntu0.24.04.1) noble-security; urgency=medium

  * No change rebuild due to golang-1.21 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Fri, 12 Jul 2024 11:05:20 +0530

prometheus-exporter-exporter (0.4.0-1build1) mantic; urgency=medium

  * No-change rebuild with Go 1.21.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 24 Aug 2023 17:17:33 +1200

prometheus-exporter-exporter (0.4.0-1) unstable; urgency=medium

  * Initial release (Closes: #968029).

 -- Johan Fleury <jfleury@arcaik.net>  Wed, 26 Aug 2020 11:43:59 +0000

=== debian/control ===
Source: prometheus-exporter-exporter
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Johan Fleury <jfleury@arcaik.net>,
Section: net
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-prometheus-client-golang-dev,
               golang-github-prometheus-client-model-dev,
               golang-github-prometheus-common-dev,
               golang-golang-x-sync-dev,
               golang-logrus-dev,
               golang-yaml.v2-dev,
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/prometheus-exporter-exporter
Vcs-Git: https://salsa.debian.org/go-team/packages/prometheus-exporter-exporter.git
Homepage: https://github.com/QubitProducts/exporter_exporter
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/QubitProducts/exporter_exporter

Package: prometheus-exporter-exporter
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: daemon | systemd-sysv,
         ${misc:Depends},
         ${shlibs:Depends},
Built-Using: ${misc:Built-Using},
Description: simple reverse proxy to other Prometheus exporters
 prometheus-exporter-exporter is intended as a single binary alternative to
 nginx/apache for use in environments where opening multiple TCP ports to all
 servers might be difficult (technically or politically).

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE=1

BUILDDIR := $(CURDIR)/build

BRANCH     := debian/sid
USER       := team+pkg-go@tracker.debian.org
BUILD_DATE  = $(shell date --utc --date='@$(SOURCE_DATE_EPOCH)' \
    +%Y%m%d-%H:%M:%S)
GO_VERSION  = $(shell go version | sed 's/go version \(\S*\).*/\1/')
BUILDFLAGS  = -ldflags \
  " -X main.Version=$(DEB_VERSION_UPSTREAM) \
    -X main.Revision=$(DEB_VERSION) \
    -X main.Branch=$(BRANCH) \
    -X main.BuildUser=$(USER) \
    -X main.BuildDate=$(BUILD_DATE) \
    -X main.GoVersion=$(GO_VERSION)"

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=$(BUILDDIR)

BINNAME := $(DEB_SOURCE)

override_dh_auto_build:
	dh_auto_build -- $(BUILDFLAGS)
	# Rename the binary to match the Debian package name.
	mv -v $(BUILDDIR)/bin/exporter_exporter $(BUILDDIR)/bin/$(BINNAME)

override_dh_auto_install:
	dh_auto_install -- --no-source

## prometheus-exporter-exporter 0.5.0

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 GITHUB_ORG  = QubitProducts
 GITHUB_REPO = exporter_exporter
-VERSION      = 0.4.0
+VERSION      = 0.5.0
 
 DOCKER_REGISTRY     = qubitproducts
 DOCKER_NAME         = exporter_exporter
@@ -75,6 +75,7 @@
 $(PACKAGE_FILE): prepare-package
 	cd dist && \
 	  fpm \
+		-f \
 	  -t $(PACKAGE_TARGET) \
 	  -m $(PACKAGE_MAINTAINER) \
 	  -n $(PACKAGE_NAME) \
@@ -89,7 +90,7 @@
 	  .
 
 .PHONY: build-docker release-docker
-build-docker: 
+build-docker:
 	docker build -t $(DOCKER_IMAGE) .
 
 release-docker: build-docker
@@ -104,12 +105,19 @@
 					-X main.BuildDate=$(BUILDDATE)
 
 build/$(BINNAME)-$(VERSION).windows-amd64/$(BINNAME).exe: $(SRCS)
-	GOOS=$* GOARCH=amd64 $(GO) build \
+	@GOOS=windows GOARCH=amd64 $(GO) build \
 	 -ldflags "$(LDFLAGS)" \
 	 -o $@ \
 	 .
-build/$(BINNAME)-$(VERSION).windows-amd64.zip: build/expoter_exporter-$(VERSION).windows-amd64/$(BINNAME).exe
-	zip $@ $<
+
+build/$(BINNAME)-$(VERSION).windows-amd64.zip: build/exporter_exporter-$(VERSION).windows-amd64/$(BINNAME).exe
+	zip -j $@ $<
+
+build/$(BINNAME)-$(VERSION).%-arm64/$(BINNAME): $(SRCS)
+	GOOS=$* GOARCH=arm64 $(GO) build \
+ 	 -ldflags "$(LDFLAGS)" \
+ 	 -o $@ \
+	 .
 
 build/$(BINNAME)-$(VERSION).%-amd64/$(BINNAME): $(SRCS)
 	GOOS=$* GOARCH=amd64 $(GO) build \
@@ -117,10 +125,13 @@
 	 -o $@ \
 	 .
 
+build/$(BINNAME)-$(VERSION).%-arm64.tar.gz: build/$(BINNAME)-$(VERSION).%-arm64/$(BINNAME)
+	cd build && \
+		tar cfzv $(BINNAME)-$(VERSION).$*-arm64.tar.gz $(BINNAME)-$(VERSION).$*-arm64
+
 build/$(BINNAME)-$(VERSION).%-amd64.tar.gz: build/$(BINNAME)-$(VERSION).%-amd64/$(BINNAME)
 	cd build && \
 		tar cfzv $(BINNAME)-$(VERSION).$*-amd64.tar.gz $(BINNAME)-$(VERSION).$*-amd64
-
 
 package: $(PACKAGE_FILE)
 
@@ -140,15 +151,22 @@
 		--name exporter_exporter-$(VERSION).windows-amd64.zip \
 		-f ./build/exporter_exporter-$(VERSION).windows-amd64.zip
 
-release-%: build/exporter_exporter-$(VERSION).%-amd64.tar.gz
+.PRECIOUS: \
+	build/exporter_exporter-$(VERSION).darwin-amd64.tar.gz \
+	build/exporter_exporter-$(VERSION).linux-arm64.tar.gz \
+	build/exporter_exporter-$(VERSION).linux-amd64.tar.gz \
+	build/exporter_exporter-$(VERSION).windows-amd64.zip
+
+
+release-%: build/exporter_exporter-$(VERSION).%.tar.gz
 	go run github.com/aktau/github-release upload \
 		-u $(GITHUB_ORG) \
 		-r $(GITHUB_REPO) \
 		--tag v$(VERSION) \
-		--name exporter_exporter-$(VERSION).$*-amd64.tar.gz \
-		-f ./build/exporter_exporter-$(VERSION).$*-amd64.tar.gz
+		--name exporter_exporter-$(VERSION).$*.tar.gz \
+		-f ./build/exporter_exporter-$(VERSION).$*.tar.gz
 
-release: 
+release:
 	git tag v$(VERSION)
 	git push origin v$(VERSION)
 	go run github.com/aktau/github-release release \
@@ -156,4 +174,4 @@
 		-r $(GITHUB_REPO) \
 		--tag v$(VERSION) \
 		--name v$(VERSION)
-	make release-darwin release-linux release-windows package-release
+	make release-darwin-amd64 release-linux-amd64 release-linux-arm64 release-windows package-release release-docker

=== debian/changelog ===
prometheus-exporter-exporter (0.5.0-1) unstable; urgency=medium

  * New upstream release.
  * gbp.conf: add defaults for import-orig.
  * d/control: add myself to Uploaders
  * d/control: bump S-V with no changes

 -- Martina Ferrari <tina@debian.org>  Thu, 13 Feb 2025 17:09:20 +0000

=== debian/control ===
Source: prometheus-exporter-exporter
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Johan Fleury <jfleury@arcaik.net>,
 Martina Ferrari <tina@debian.org>,
Section: net
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 golang-any,
 golang-github-prometheus-client-golang-dev,
 golang-github-prometheus-client-model-dev,
 golang-github-prometheus-common-dev,
 golang-golang-x-sync-dev,
 golang-logrus-dev,
 golang-yaml.v2-dev,
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/prometheus-exporter-exporter
Vcs-Git: https://salsa.debian.org/go-team/packages/prometheus-exporter-exporter.git
Homepage: https://github.com/QubitProducts/exporter_exporter
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/QubitProducts/exporter_exporter

Package: prometheus-exporter-exporter
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 daemon | systemd-sysv,
 ${misc:Depends},
 ${shlibs:Depends},
Built-Using:
 ${misc:Built-Using},
Description: simple reverse proxy to other Prometheus exporters
 prometheus-exporter-exporter is intended as a single binary alternative to
 nginx/apache for use in environments where opening multiple TCP ports to all
 servers might be difficult (technically or politically).
